DCO_BASE_DIR=../../..
CXXFLAGS=-Wall -pedantic -Wextra -O3 -DNDEBUG -Werror -O3 -I$(DCO_BASE_DIR)/include -DDCO_DISABLE_AUTO_WARNING -fopenmp 
CXX=g++

source=main.cpp
objects=$(source:.cpp=.o)

all : main.exe run check 

main.exe : $(objects)
	$(CXX) $^  $(DCO_BASE_DIR)/lib/libdcoc.a -ldl -o main.exe -fopenmp

run : main.exe
	./main.exe 5 > out

check : run
	-diff --strip-trailing-cr out ref_results

generate_results : main.exe
	./main.exe 5 > ref_results

%.o : %.cpp
	$(CXX) $(CXXFLAGS) -c $^

clean:
	rm -f *.o main.exe out
